
package de.ivu.elect.presentation.entschaedigung;

import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungConversationStore;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungExtendedDAO;
import de.ivu.elect.business.entschaedigung.boundary.EntschaedigungEdit;
import de.ivu.elect.business.entschaedigung.entity.Entschaedigung;
import de.ivu.elect.business.entschaedigung.entity.EntschaedigungMeta;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.business.security.UseCaseSecure;
import de.ivu.elect.presentation.View;
import de.ivu.elect.jee.presentation.redirect.Redirect;

@Named(AbstractEntschaedigungEditNoScopeView.COMPONENT_NAME)
@View(viewId = AbstractEntschaedigungEditNoScopeView.VIEW_ID, useCase = UseCasePermission.ENTSCHAEDIGUNG_EDIT)
public abstract class AbstractEntschaedigungEditNoScopeView extends de.ivu.elect.presentation.AbstractElectEditView<Entschaedigung>  {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "entschaedigungEditView";

  public static final String VIEW_ID = "/entschaedigung/entschaedigung-edit.xhtml";

  public static final String PARENT_VIEW_ID = "/entschaedigung/entschaedigung-search.xhtml";

  @Inject
  protected transient EntschaedigungExtendedDAO extendedDAO;

  @Inject
  protected transient EntschaedigungEdit edit;

  @Inject
  @ConversationGroup(EntschaedigungConversationStore.class)
  protected transient EntschaedigungConversationStore conversationStore;

  @Inject
  protected transient EntschaedigungMeta entityMeta;

  @Inject
  // ELECTDD-204 Auf doppelte Bearbeitung von Entitäten Hinweisen
  protected transient EntschaedigungEditViewScopeStore entityViewStore;

  @de.ivu.elect.jee.faces.PreConditionCheck
  public String checkPreCondition() {
    if (getEntity() == null) {
      return getParentViewId();
    }
    return null;
  }

  @Override
  public Entschaedigung getEntity() {
    if (conversationStore.getEntityPK() != null) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }
    return null;
  }

  public void setEntity(Entschaedigung entity) {
    resetModel(); // DynaForm-Model zurücksetzen, damit die aktuelle Entität verwendte wird...
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  public boolean isEntitySet() {
    return conversationStore.getEntityPK() != null;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_DELETE)
  @Override
  public String delete() {
    return delete(getEntity());
  }

  protected String delete(Entschaedigung entity) {
    edit.delete(entity);

    addMessageDeleteSuccess();

    resetStateAfterAction();
    return getParentViewId(); // definierter Parent, benutze deleteAndGoBack um zum vorherigen View zurückzukehren
  }



  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_DELETE)
  public String deleteAndGoBack() {
    delete();
    return goBack(getParentViewId());
  }

  protected void addMessageDeleteSuccess() {
    addInfoMessage("entity.edit.action.delete.success.message", entityMeta.getEinzahlMessage());
  }

  public boolean isBtnDeleteRendered() {
    return hasPermission(UseCasePermission.ENTSCHAEDIGUNG_DELETE);
  }

  @Redirect
  @Override
  public String cancel() {
    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  @Override
  public boolean isBtnCancelRendered() {
    return true;
  }

  @Redirect
  @UseCaseSecure(UseCasePermission.ENTSCHAEDIGUNG_EDIT)
  @Override
  public String save() {
    Entschaedigung entity = getEntity();

    callSave(entity);

    addMessageSaveSuccess(entity);

    resetStateAfterAction();

    return goBack(getParentViewId());
  }

  protected void callSave(Entschaedigung entity) {
    edit.save(entity);
  }

  @Redirect
  @Override
  public String reset() {
    super.reset();
    Entschaedigung entity = getEntity();
    resetStateAfterAction();
    setEntity(entity);
    return getViewId();
  }

  protected void addMessageSaveSuccess(Entschaedigung entity) {
    addInfoMessage("entity.edit.action.save.success.message", entityMeta.getEinzahlMessage());
  }

  @Override
  protected boolean isSavePermissionVorhanden() {
    return hasPermission(UseCasePermission.ENTSCHAEDIGUNG_EDIT);
  }
  
  @Redirect
  public String edit(Entschaedigung entity) {
    conversationStore.setEntityPK(entity.getPk());
    return getViewId();
  }

  protected String getViewId() {
    return VIEW_ID;
  }

  protected String getParentViewId() {
    return PARENT_VIEW_ID;
  }

  protected void resetStateAfterAction() {
    conversationStore.close();
  }

  @de.ivu.elect.jee.faces.PreConditionCheck
  public void checkDoppelteBearbeitung() {
     entityViewStore.setEntity(getEntity());
  }

  @org.apache.deltaspike.core.api.scope.ViewAccessScoped
  public static class EntschaedigungEditViewScopeStore extends  de.ivu.elect.presentation.edit.AbstractViewScopeStore<Entschaedigung,   de.ivu.elect.business.entschaedigung.entity.EntschaedigungPK  > {

    private static final long serialVersionUID = 1L;
  }
}
